routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect()->route('home');
});
Route::get('/home', 'HomeController@home')->name('home');

Auth::routes();


Route::resource('users', 'UserController');
//Route::get('/users', 'UserController@users')->name('users')->middleware('permission:view-users');
//Route::get('/users/create', 'UserController@create')->name('users.create')->middleware('permission:view-users');
//Route::post('/users', 'UserController@store')->name('users.store')->middleware('permission:view-users');
//Route::get('/users/{id}/edit', 'UserController@create')->name('users.create')->middleware('permission:view-users');
//Route::post('/users', 'UserController@store')->name('users.store')->middleware('permission:view-users');
//


Route::get('/user-edit-permissions/{id}', 'UserController@userEditPermissions')->name('user-edit-permissions')->middleware('permission:update-permissions');
Route::put('/user-edit-permissions/{id}', 'UserController@userUpdatePermissions')->middleware('permission:view-users');


Route::get('/profile', 'UserController@show')->name('profile');

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    // using permission trait for using permissions
    use PermissionsTrait;
    use Notifiable;
//use PermissionsTrait;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];


}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Http\Controllers\Auth\RegisterController;
use App\Permission;
use App\Role;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;

class UserController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {


        $this->middleware('auth')->except('home');
    }



    /**
     * listing all users
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function index()
    {
        // checking permission for accessing index
        $this->authorize('index', User::class);

        // eager loading roles for users
        $users = User::with('roles')->get();

        // displaying list view
        return view('users.index', compact('users'));
    }


    /**
     *
     * get all permissions for users page
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function userEditPermissions($id)
    {
        // get requested user
        $user = User::with('roles')->find($id);
        // get all roles to list them later
        $roles = Role::all();
        // get all permissions to list them later
        $permissions = Permission::all();
        // displaying permissions page
        return view('users.permissions', compact('user', 'roles', 'permissions'));
    }


    /**
     * updating user permissions
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function userUpdatePermissions($id)
    {
        // find edited user
        $user = User::find($id);

        // get the old user roles by slugs
        $givenRoles = $user->roles->pluck('slug');
        // collecting the new roles
        $newRoles = collect(\request('roles'));
        // get the new roles
        $recentlyAddedRoles = $newRoles->diff($givenRoles);
        // get the removed roles
        $recentlyRemovedRoles = $givenRoles->diff($newRoles);
        // removing unchecked roles
        $user->removeRolesFrom($recentlyRemovedRoles->toArray());
        // saving the recently new roles for the user
        $user->giveRoleTo($recentlyAddedRoles->toArray());

        // doing same as roles
        $givenPermissions = $user->permissions->pluck('slug');
        $newPermissions = collect(\request('permissions'));
        $recentlyAddedPermissions = $newPermissions->diff($givenPermissions);
        $recentlyRemovedPermissions = $givenPermissions->diff($newPermissions);
        $user->removePermissionsFrom($recentlyRemovedPermissions->toArray());
        $user->givePermissionTo($recentlyAddedPermissions->toArray());

        // redirecting to index
        return redirect()->route('users.index')->with('message', ['class' => 'alert-success', 'value' => 'Success']);

    }

    public function create()
    {
        // checking gate for creating user
        $this->authorize('create', User::class);

        return view('users.create');
    }

    public function edit($id)
    {
        $user = User::find($id);
        return view('users.edit', compact('user'));
    }

    public function store()
    {
        // validating the inserted data
        \request()->validate([
            'name' => ['required', 'string', 'max:255'],
            'email' => ['required', 'string', 'email', 'max:255', 'unique:users'],
            'password' => ['required', 'string', 'min:8', 'confirmed'],
        ]);
        $user = User::create([
            'name' => \request('name'),
            'email' => \request('email'),
            'password' => Hash::make(\request('password')),
        ]);

        return redirect()->route('user-edit-permissions', ['id' => $user->id])->with('message', ['class' => 'alert-success', 'value' => 'Success'])->with(compact('user'));
    }

    /**
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Illuminate\Validation\ValidationException
     */
    public function update($id)
    {

        $user = User::find($id);
        $request = \request()->all();
        // validating only name
        $this->validate(\request(), [
            'name' => ['required', 'string', 'max:255'],
        ]);
        // removing password
        if ($request['password'] == '') {
            unset($request['password']);
        } else {
            $this->validate(\request(), [
                'password' => ['required', 'string', 'min:8', 'confirmed'],
            ]);
            $user->password = Hash::make(\request('password'));
        }
        // saving only name to the old user
        $user->name = \request('name');

        $user->save();

        return redirect()->route('users.index', ['id' => $user->id])->with('message', ['class' => 'alert-success', 'value' => 'Success'])->with(compact('user'));
    }

    /**
     * display any user profile or the authenticated user profile
     * @param null $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function show($id = null)
    {

        if ($id === null) {

            $user = Auth::user();
        } else {
            $user = User::find($id);
        }
        $this->authorize('profile', $user);

        return view('users.show', compact('user'));
    }


}

resources/views/users/create.blade.php
@extends('users.inputs-layout',['mode'=>'create'])

@section('inputs')

@endsection

resources/views/users/edit.blade.php
@extends('users.inputs-layout',['mode'=>'edit'])

@section('inputs')

@endsection

resources/views/users/index.blade.php
@extends('layouts.app')
@section('content')

    <div class="container-fluid">
        @can('create-users')
            <a href="{{route('users.create')}}">
                <button class="btn btn-success">Create User</button>
            </a>
        @endcan()
        <table class="table table-striped">

            <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Email</th>
                <th scope="col">Name</th>
                <th scope="col">Roles</th>
                <th scope="col">Actions</th>
            </tr>
            </thead>
            <tbody>
            @foreach($users as $user)
                <tr>
                    <th scope="row">{{$user->id}}</th>
                    <td>{{$user->email}}</td>
                    <td>{{$user->name}}</td>
                    <td>{{implode(' , ',$user->roles->pluck('name')->toArray())}}</td>
                    <td>
                        @can('update-permissions')

                            <a class="" href="{{route('user-edit-permissions',['id'=>$user->id])}}">
                                <button class="btn btn-primary">Permissions</button>

                            </a>
                        @endcan()

                        @can('update-users')
                            <a class="" href="{{route('users.edit',['id'=>$user->id])}}">
                                <button class="btn btn-secondary">Edit</button>
                            </a>
                        @endcan()
                        @can('view-users')
                            <a class="" href="{{route('users.show',['id'=>$user->id])}}">
                                <button class="btn btn-outline-secondary">View</button>
                            </a>
                        @endcan()


                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
@endsection

resources/views/users/inputs-layout.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">
                        @switch($mode)
                            @case('create')
                            {{ __('Creating') }}
                            @break
                            @case('edit')
                            {{ __('Editing') }}
                            @break

                            @case('show')
                            {{ __('Viewing') }}
                            @break

                        @endswitch
                        {{ __('User') }}

                    </div>
                    <div class="card-body">
                        <form method="POST"
                              @if ($mode!='show')

                              @if ($mode=='create')
                              action="{{ route('users.store') }}"
                              @endif
                              @if ($mode=='edit')
                              action="{{ route('users.update', ['id'=>$user->id])}}"
                            @endif
                            @endif >


                            @if ($mode=='edit')
                                @method('PUT')
                            @endif

                            @csrf

                            <div class="form-group row">
                                <label for="name" class="col-md-4 col-form-label text-md-right">{{ __('Name') }}</label>

                                <div class="col-md-6">
                                    <input id="name" type="text"
                                           @if ($mode == 'show' || $mode == 'edit') value="{{$user->name}}" @endif
                                           @if ($mode == 'show' )  readonly @endif

                                           class="form-control{{ $errors->has('name') ? ' is-invalid' : '' }}"
                                           name="name" value="{{ old('name') }}" required autofocus>

                                    @if ($errors->has('name'))
                                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('name') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            </div>

                            <div class="form-group row">


                                <label for="email"
                                       class="col-md-4 col-form-label text-md-right">{{ __('E-Mail Address') }}</label>

                                <div class="col-md-6">
                                    <input id="email" type="email"
                                           @if ($mode == 'show' || $mode == 'edit') value="{{$user->email}}" readonly
                                           @endif
                                           class="form-control{{ $errors->has('email') ? ' is-invalid' : '' }}"
                                           name="email" value="{{ old('email') }}" required>

                                    @if ($errors->has('email'))
                                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('email') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            </div>

                            <div class="form-group row">
                                <label for="password" value=""

                                       class="col-md-4 col-form-label text-md-right">{{ __('Password') }}</label>

                                <div class="col-md-6">
                                    <input id="password" type="password"
                                           class="form-control{{ $errors->has('password') ? ' is-invalid' : '' }}"
                                           name="password"
                                           @if ($mode!='edit')
                                           required

                                        @endif
                                    >

                                    @if ($errors->has('password'))
                                        <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('password') }}</strong>
                                    </span>
                                    @endif
                                </div>
                            </div>

                            <div class="form-group row">
                                <label for="password-confirm"
                                       class="col-md-4 col-form-label text-md-right">{{ __('Confirm Password') }}</label>

                                <div class="col-md-6">
                                    <input id="password-confirm" type="password" class="form-control"
                                           name="password_confirmation"
                                           @if ($mode!='edit')
                                           required

                                        @endif>
                                </div>
                            </div>

                            <div class="form-group row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    @if ($mode =='show')
                                        <a href="{{route('users.index')}}"><button type="button"  class="btn btn-outline-dark">Cancel
                                            </button></a>
                                    @else
                                        <button type="submit" class="btn btn-success">
                                            @switch($mode)
                                                @case('create')
                                                {{ __('Create') }}
                                                @break
                                                @case('edit')
                                                {{ __('Apply') }}
                                                @break



                                            @endswitch
                                        </button>
                                    @endif

                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @yield('inputs')
@endsection

resources/views/users/permissions.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <form method="POST" >
                    @csrf
                    @method('PUT')

                    <div class="form-group row">
                        <label for="staticEmail" class="col-sm-2 col-form-label">Email</label>
                        <div class="col-sm-10">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail"
                                   value="{{$user->email}}">
                        </div>
                    </div>

                    <div class="form-group row">
                        <label for="staticEmail" class="col-sm-2 col-form-label">Name</label>
                        <div class="col-sm-10">
                            <input type="text" readonly class="form-control-plaintext" id="staticEmail"
                                   value="{{$user->name}}">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="staticEmail" class="col-sm-2 col-form-label">Roles</label>
                        <div class="col-sm-10">
                            @foreach($roles as $role)
                                <div class="form-check form-check-inline">
                                    <?php $selectedRoles = $user->roles->pluck('id') ?>
                                    <input name="roles[]"
                                        @if(in_array($role->id,$selectedRoles->toArray()))checked="checked" @endif
                                    class="form-check-input" type="checkbox" id="role{{$role->slug}}"
                                        value="{{$role->slug}}">
                                    <label class="form-check-label" for="role{{$role->slug}}">{{$role->name}}</label>
                                </div>
                            @endforeach
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="staticEmail" class="col-sm-2 col-form-label">Additional Permissions</label>
                        <div class="col-sm-10">
                            @foreach($permissions as $permission)
                                <div class="form-check form-check-inline">
                                    <?php $selectedRoles = $user->permissions->pluck('id') ?>
                                    <input name="permissions[]"
                                        @if(in_array($permission->id,$selectedRoles->toArray()))checked="checked" @endif
                                    class="form-check-input" type="checkbox" id="permission{{$permission->slug}}"
                                        value="{{$permission->slug}}">
                                    <label class="form-check-label" for="permission{{$permission->slug}}">{{$permission->name}}</label>
                                </div>
                            @endforeach
                        </div>
                    </div>

                    <button type="submit" class="btn btn-success">Save</button>
                    <button type="button" class="btn btn-dark">Cancel</button>

                </form>
            </div>
        </div>
    </div>

@endsection

resources/views/users/show.blade.php
@extends('users.inputs-layout',['mode'=>'show'])

@section('inputs')

@endsection